<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 02/04/2005 *
 * ================                             Last change: 11/19/2005 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-list_bonus.php                              *
 * -------------------------------------------------------------------- *
 * Short description : List members in active-rallye                    *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Mitglieder in Aktiv-Rallye auflisten             *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((ereg(basename(__FILE__), $_SERVER['PHP_SELF'])) || (!is_admin()))
{
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}
// Add description as navigation point
ADD_DESCR("admin", basename(__FILE__));

if ($_CONFIG['bonus_active'] == "Y") {
	// Shall I withdraw now?
	if (isset($_POST['withdraw'])) {
		// Okay, let's prepare...
		$curr = date("m", time()) - 1;
		if (strlen($curr) == 1) $curr = "0".$curr;
		UPDATE_CONFIG("last_month", $curr);
		LOAD_TEMPLATE("admin_settings_saved", false, ADMIN_BONUS_WITHDRAW_PREPARED);
		OUTPUT_HTML("<br />");
	}

	if (GET_EXT_VERSION("bonus") >= "0.6.9") {
		// Add more bonus points here
		$USE = "(0";
		if ($_CONFIG['bonus_click_yn'] == "Y") $USE .= " + turbo_bonus";
		if ($_CONFIG['bonus_login_yn'] == "Y") $USE .= " + login_bonus";
		if ($_CONFIG['bonus_order_yn'] == "Y") $USE .= " + bonus_order";
		if ($_CONFIG['bonus_stats_yn'] == "Y") $USE .= " + bonus_stats";
		if ($_CONFIG['bonus_ref_yn']   == "Y") $USE .= " + bonus_ref";
		$USE .= ")";
	} else {
		// Old version ???
		$USE = "turbo_bonus";
	}

	// Autopurge installed?
	$LAST = "%s"; $ONLINE = "";
	if (EXT_IS_ACTIVE("autopurge")) {
		// Use last online timestamp to keep inactive members away from here
		$LAST   = " AND last_online >= %s";
		$ONLINE = bigintval(time() - $_CONFIG['ap_in_since']);
	}

	// Check if at least one is in the active rallye
	$result = SQL_QUERY_ESC("SELECT userid, email, gender, surname, family, ".$USE." AS active_bonus, last_online
FROM "._MYSQL_PREFIX."_user_data
WHERE status='CONFIRMED' AND ".$USE." > 0".$LAST."
ORDER BY active_bonus DESC, last_online DESC, userid",
	 array($ONLINE), __FILE__, __LINE__);

	if (SQL_NUMROWS($result) > 0) {
		// List users
		$OUT = "";$SW = 2; $cnt = 1; $total = 0;
		while(list($uid, $email, $gender, $sname, $fname, $turbo, $last) = SQL_FETCHROW($result)) {
			// Generate array fore the dynamic template
			$WIN1 = ""; $WIN2 = "";
			if ($cnt <= $_CONFIG['bonus_ranks']) {
				// Maybe he can win his active bonus?
				$WIN1 = "<STRONG>";
				$WIN2 = "</STRONG>";
			}

			// Prepare content
			$content = array(
				'uid'    => $uid,
				'email'  => CREATE_EMAIL_LINK($email, "user_data"),
				'gender' => TRANSLATE_GENDER($gender),
				'sname'  => $sname,
				'fname'  => $fname,
				'turbo'  => TRANSLATE_COMMA($turbo),
				'last'   => MAKE_DATETIME($last, "2"),
				'sw'     => $SW,
				'win1'   => $WIN1,
				'win2'   => $WIN2,
				'cnt'    => $cnt,
			);

			// Load template and add it
			$OUT .= LOAD_TEMPLATE("admin_list_bonus_rows", true, $content);
			$SW = 3 - $SW; $cnt++; $total += $turbo;
		}
		define('__BONUS_ROWS', $OUT);
		define('__TOTAL', TRANSLATE_COMMA($total));

		// Check if we need to display form or not with manuel withdraw
		if ($_CONFIG['last_month'] == date("m", time()))
		{
			// Load form
			define('__BONUS_WITHDRAW_FORM', LOAD_TEMPLATE("admin_list_bonus_form", true));
		}
		 else
		{
			// Display message "no manual withdraw possible"
			define('__BONUS_WITHDRAW_FORM', "<FONT class=\"admin_failed\">".ADMIN_BONUS_ALREADY_WITHDRAW."</FONT>");
		}

		// Prepare constant for timemark
		define('__AUTOPURGE_TIMEOUT', MAKE_DATETIME(time() - $_CONFIG['ap_in_since'], "2"));

		// Load final template
		LOAD_TEMPLATE("admin_list_bonus");
	}
	 else
	{
		// No one has become an "activity bonus"...
		LOAD_TEMPLATE("admin_settings_saved", false, ADMIN_BONUS_NO_ACTIVE_RALLYE);
	}
}
 else
{
	// Aktive-Rallye not activated
	LOAD_TEMPLATE("admin_settings_saved", false, ADMIN_BONUS_RALLYE_DEACTIVATED);
}

//
?>
